(* This module defines sets and maps over strings. *)

module StringSet = Set.Make(String)

module StringMap = struct

  include Map.Make(String)

  let singleton k v =
    add k v empty

  let foldv f accu map =
    fold (fun _ x accu ->
      f accu x
    ) map accu

  let domain map =
    fold (fun k _ s ->
      StringSet.add k s
    ) map StringSet.empty

  let union m1 m2 =
    fold add m1 m2

  let diff map set =
    StringSet.fold remove set map

  let elements m =
    fold (fun k d elements ->
      (k, d) :: elements
    ) m []

end

